#include "stdio.h"
#include "stdbool.h"

void bool_samples(void) {
  bool b = true;

  printf("Ein bool mit Wert %d\n", b);
  printf("Ein bool mit Wert %d\n", false);
  /* jetzt wollen wir true/false drucken: */
  printf ("Ein bool als ein bool %s\n", (b ? "true" : "false"));

  printf ("Ein bool wird in %lu bytes abgespeichert.\n", sizeof (bool));

  b = 256;
  printf("Ein bool 256 mit Wert %d\n", b);
}

unsigned int factorial ( int n ) {
  // n > 0
  unsigned int r = 1;
  for (unsigned int i = 1; i <= n; i++ ) {
    r = r * i;
  }
  return r; // n!
}

void int_samples(void) {
  int i = 42;
  printf ("Ein int wird auf diesem System in %lu bytes abgespeichert.\n", sizeof (int));

  printf ("Was passiert, wenn ein  int zu gross wird?\n");
  int test = 1;
  for (int j = 1; j <= 40; j++ ) {
    printf ("test = %d\n", test);
    test = 2 * test;
  }

  printf ("Was wenn ein int zu gross wird (Teil 2)\n");
  for (int n = 1; n <= 34; n++ ) {
    printf ("factorial (%d) = %u\n", n, factorial(n));
  }
}

void char_samples(void) {
  char letter_a = 'A';

  printf ("Der character A ist wirklich %d\n", letter_a);
  printf ("Hier ist der Beweis: %c\n", 65);
  printf ("Hier noch die Null: %c\n", 48);
}

void question(void) {
  // was ist mit (x++)++? ist das gleich x += 2?
  // nein: unter dem ++ muss eine Variable oder Arrayreferenz (linke Seite Zuweisung) stehen.

  // Gibt es elif? Nein:
  if (false) {
    // bla
  } else if (true) {
    // wird ausgefuehrt
  } else {
    // nicht erreichbar
  }
}

#define KEY_UP 'w'
#define KEY_DOWN 'z'

int getch(void) {
  return KEY_UP;
}

void getch_example(void) {
  int ch = getch();
  int y = 0;
  switch (ch) {
  case KEY_UP: y -= 1; break;
  case KEY_DOWN: y += 1; break;
  default:
    // Aktion f nicht erkannte Taste
    break;
  }
}

void string_samples(void) {
  
  char versuch[] = "ein versuch";
  printf ("versuch = %s\n", versuch);
  versuch[5] = '0';
  printf ("versuch = %s\n", versuch);
  versuch[5] = 0;
  printf ("versuch = %s\n", versuch);
  
}

int main(void) {
  bool_samples();
  char_samples();
  int_samples();
  string_samples();
}
